@echo off
color f0
title %~n0
::------------------------------------------------------------------------------------------------------
::  ࠬ ਯ
set $app=ciadpi.exe
set $serviceName=ByeDpi
set "$scriptDir=%~dp0"
set $scriptFile=%~nx0
set $iniFile=%~n0.ini
set $logFile=%~n0.log
set $checkListsDir=CheckLists
set $blackListsDir=BlackLists
set $filesDir=Files
set $configsFile=%$filesDir%\Configs.txt
set $ipsFile=%$filesDir%\IPs.ini
set $dohFile=%$filesDir%\DoH.txt
set $dnsFile=%$filesDir%\DNS.txt
set $curlDir=%$filesDir%\curl
set $curl=curl-impersonate.exe
set $curlLog=curl.log
::------------------------------------------------------------------------------------------------------
setlocal enableExtensions enableDelayedExpansion

pushd "!$scriptDir!"

call :Show Info "%date% ----------------------------------------------------------------------------"

::   ࠭ cmd  . ஢
call :SetCodePage 866

@echo ஢ઠ  室 䠩
for %%f in ("%$app%" "%$curlDir%\%$curl%" "%$configsFile%" "%$iniFile%") do (
	if not exist %%f call :Show Error "  '%%~f'. , : 1.䠩  㤠 ⨢ᮬ; 2.'%$scriptFile%' ᯠ   ⠫  '%$app%'")

start "" "%$app%"
timeout /nobreak /t 1 1>nul 2>&1
taskkill /t /f /im "%$app%" 1>nul 2>&1 || call :Show Error " 㤠   '%$app%'. '%$scriptFile%'   饭  ࠢ  [ࠢ    䠩 -  '   ']"

call :LoadSettingsFrom "%$iniFile%"
call :Show Info "㦥 ன  '%$iniFile%': [$ip=%$ip%]; [$port=%$port%]; [$paramsGlobal=%$paramsGlobal%]; [$configsDefault=%$configsDefault%]; [$deleteServices=%$deleteServices%]; [$interactive=%$interactive%]; [$curlFreezes=%$curlFreezes%]; [$curlKeys=%$curlKeys%]; [$browser=%$browser%]; [$timeout=%$timeout%]; [$maxRetry=%$maxRetry%]; [$maxParallel=%$maxParallel%]; [$checkCount=%$checkCount%]; [$whiteList=%$whiteList%]; [$sniList=%$sniList%]; [$oobData=%$oobData%]; [$fakeDataTls=%$fakeDataTls%]; [$fakeDataUdp=%$fakeDataUdp%]; [$ggc=%$ggc%];"
call :Show Info " ᯨ᮪ 䨣権 '%$configsFile%'"

if /i "%$deleteServices%"=="yes" (
	for /f "tokens=1* delims=: " %%r in ('sc query state^= all ^|findstr /i /c:"%$serviceName%"') do (
		if /i "%%~r"=="service_name" sc delete %%s 1>nul 2>&1 || call :Show Warning "'%$scriptFile%'   饭  ࠢ  [ࠢ    䠩 -  '   ']")
	call :Show Info "㦡 %$serviceName% 㤠")

if /i "%$browser%"=="chrome124" (
	set textForBrowserVer= Kyber
) else (
	set textForBrowserVer=⪫ Kyber)

@echo ஢ઠ ᠩ⮢   ᯨ᪠: [%$whiteList%]
call :CheckSites whiteList "%$whiteList%"
if not defined whiteList.Yes call :Show Error "१ ⨫ %$curl%  㯥    ᠩ⮢ [%$whiteList%]. 1.஢ ୥-ᮥ; 2.஢ 㦡 DNS-; 3.  室騥   %$curl%  䠥ࢮ [⨢/࠭]  ⪫ ᫥  ६ ஢ન."

for %%s in (%whiteList.Yes%) do set sni=%%s
@echo ᯮ 㯭  %sni%  ⢥ sni [server name indication]
call :GetIpsByNslookup "%sni%"
if not defined %sni%.ip call :Show Error " 㤠  ip  %sni% ⥬ ⨫⮩ nslookup. ,     䠥ࢮ [⨢/࠭]"
::------------------------------------------------------------------------------------------------------
:heckList
cls
set checkLists=
for /f "tokens=*" %%f in ('dir /b "%$checkListsDir%\*.txt"') do set checkLists=!checkLists! %%f
call :GetChoice checkList "%checkLists%" "" "8" "롥 祪 [ᯨ᮪ ᠩ⮢  ஢ન]"

call :Show Info "࠭ 祪: '%$checkListsDir%\%checkList%'"
set urls=
set urls.Count=0
for /f "usebackq tokens=* eol=# delims=" %%u in ("%$checkListsDir%\%checkList%") do (
	set urls=%%u !urls!
	set /a urls.Count +=1)
if "%urls.Count%"=="0" call :Show Error " 䠩 祪 '%checkList%'  ᠩ⮢  ஢ન"

set domainsInit=%urls:https://=%
set domainsInit=%domainsInit:http://=%
call :Show Info " 祪 㦥 : [%domainsInit%]"

@echo  ⥬ ip    祪
set domains=
call :GetIpsByNslookup "%domainsInit%"
for %%d in (%domainsInit%) do (	
	if defined %%d.ip (
		set domains=%%d !domains!
	) else (
		call :Show Warning " %%d ᪫祭  ஢ન ..    ip-. ஡    '%checkList%'   .. xxx.%%d"))
if not defined domains call :Show Error " ᮦ,    ஢ન"

call :LoadSettingsFrom "%$ipsFile%"
call :Show Info "㦥 ࠡ稥 ip-   䠩 '%$ipsFile%'"

@echo ஢ઠ 㯭  ip : [%domains%]
call :CheckIps domains "%domains%"

if not defined domains.IpNo goto :curlSettings
call :Show Info " 㯭  ip- : [%domains.IpNo%]"

@echo 㧪  䠩 ᯨ᪠ ࢥ஢ dns  DoH
set dnsServers=
set dohServers=
for %%d in (dns doh) do (
	if exist "!$%%dFile!" (
		for /f "usebackq skip=1 tokens=1" %%s in ("!$%%dFile!") do set %%dServers=%%s !%%dServers!		
	) else (
		call :Show Warning "  䠩  ᯨ᪮ ࢥ஢ %%d '!$%%dFile!'"))

call :CheckSites dohServers "%dohServers%"
if not defined dohServers.Yes (
	call :Show Warning " 㯥    ࢥ஢ DoH [Dns-over-Https]: [%dohServers%]"
	goto :findIpsByDnsServers)

set dohFromIni=!$doh.%checkList%!
if defined dohFromIni set dohServers=!dohServers.Yes:%dohFromIni%=!
call :Show Info " ࠡ ip १ DoH [%dohFromIni% %dohServers.Yes%]"
for %%s in (%dohFromIni% %dohServers.Yes%) do (
	call :CheckDoh dohFound "%%s" "%domains.IpNo%"
	if "!dohFound!"=="true" (
		call :Show Info " 㯭  ip ᠩ⮢   ன 㧥/  dns [ Dns over Https]    %%s  樨 https://www.comss.ru/page.php?id=4950 [Firefox] / https://www.comss.ru/page.php?id=6421 [Chrome].   ࠡ稥 ip  䠩 '%$ipsFile%'    䠩 '%SystemRoot%\System32\drivers\etc\hosts' ७ࠢ  ଠ: ip   ਬ: 146.112.41.2 doh.opendns.com"
		call :SaveSettingTo "%$iniFile%" "$doh.%checkList%" "%%s"
		call :LoadSettingsFrom "%$ipsFile%"
		goto :curlSettings))

:findIpsByDnsServers
call :Show Info " ࠡ ip १ ஭ dns [%dnsServers%]"
for %%s in (%dnsServers%) do (
	call :GetIpsByNslookup "!domains.IpNo!" "%%s"
	call :CheckIps domainsFail "!domains.IpNo!"
	if defined domainsFail.IpYes (
		set domains.IpYes=!domains.IpYes! !domainsFail.IpYes!
		set domains.IpNo=!domainsFail.IpNo!)
	if not defined domains.IpNo (
		call :Show Info " 㯭  ip ᠩ⮢ ᬥ  ⥢ ன/ dns  %%s  樨 https://www.comss.ru/page.php?id=754   ࠡ稥 ip  䠩 '%$ipsFile%'    '%SystemRoot%\System32\drivers\etc\hosts' ७ࠢ  ଠ: ip   ਬ: 146.112.41.2 doh.opendns.com"
		goto :curlSettings))

call :Show Warning " 㤠  ࠡ稥 ip  : [%domains.IpNo%].   ᪫  ஢ન."
set domains=%domains.IpYes%

:curlSettings
@echo ନ஢ ᯨ᪠ ᮢ  ࠬ஢  %$curl%
if not defined domains call :Show Error " ᮦ,    ஢ન"
set checkUrls=
for %%d in (%domains%) do (
	set checkUrls=!checkUrls! https://%%d --output nul
	if defined %%d.ip set checkUrls=!checkUrls! --connect-to %%d::!%%d.ip!)

for %%p in (config header) do (
	if not exist "%$curlDir%\browsers\%$browser%.%%p" call :Show Warning "  䠩 '%$curlDir%\browsers\%$browser%.%%p'  ன %$curl%")

set curlKeys=--config browsers\%$browser%.config --header @browsers\%$browser%.header %$curlKeys% --proxy socks5://%$ip%:%$port% --max-time %$timeout% --retry %$maxRetry% --write-out "%%output{>>"%$curlLog%"}code=%%{response_code};error=%%{exitcode};ssl=%%{ssl_verify_result};%%{url}\n" --parallel --parallel-max %$maxParallel% --fail-early

call :CheckIps sniList "%$sniList%"
if defined sniList.IpYes (
	for %%s in (%sniList.IpYes%) do set $fakeSni=%%s
	call :Show Info " 䥩 sni [$fakeSni=!$fakeSni!]"
) else (
	call :Show Warning " 㤠  $fakeSni ..  㯥     %$sniList%")	

set blackList=%$blackListsDir%\%checkList%
if not exist "%blackList%" (
	(for %%d in (%domains%) do @echo.%%d)>"%blackList%")
call :Show Info "ᯮ  %blackList%"

set /a d=urls.Count/$maxParallel
if %$maxParallel% gtr %urls.Count% set d=1
set /a checkTime=d*$timeout*($maxRetry + 1) + 1

call :Show Info " 饩 䨣樨  %urls.Count% . ᨬ쭮 ६ ஢ન  䨣樨 - %checkTime%x%$checkCount% ᥪ㭤[]"
call :FindConfig config "%checkUrls%" "%blackList%"
if not defined config goto :scriptEnd

set configCheckList=--hosts '%blackList%' %config% --auto=n
set configName=%checkList:.txt=%
call :SaveConfigToFile "%configCheckList%" "%configName%"

type "%$checkListsDir%\%checkList%"|findstr /i /c:"youtube" 1>nul 2>&1 || goto :scriptEnd
call :Show Info " -ࢥ 㡠 .. GGC [Google Global Cache]"

if not defined $ggc (
	call :GetLocalGGCs ggcsLocal
	if defined ggcsLocal call :CheckIps ggcsLocal "!ggcsLocal!"
	if defined ggcsLocal.IpYes (
		for %%g in (!ggcsLocal.IpYes!) do set $ggc=%%g
		call :SaveSettingTo "%$iniFile%" "$ggc" "!$ggc!"))

if not defined $ggc (
	call :Show Warning " 㤠 ।  襣 GGC. ᫨   ந뢠,     GGC  ࠬ $ggc  '%$iniFile%'    䨣樨  ⥬  祪⮬.    GGC: 1. cmd  㡠; 2. ஫  㡥; 3.맢  㧥  F12  CTRL+SHIFT+J; 4.  /Network; 5.  㤠  [᭮ 梥]   rr...googlevideo.com -    GGC [᪮஢  ,    楫]"
	goto :scriptEnd)

call :Show Info " 襣 GGC: https://%$ggc%"
call :CheckIps $ggc "%$ggc%"
if defined $ggc.IpNo (
	call :Show Warning " GGC  㯥  ip. ᫨   ந뢠,   .  GGC  ࠬ $ggc  '%$iniFile%'    䨣樨  ⥬  祪⮬.    GGC: 1. cmd  㡠; 2. ஫  㡥; 3.맢  㧥  F12  CTRL+SHIFT+J; 4.  /Network; 5.  㤠  [᭮ 梥]   rr...googlevideo.com -    GGC [᪮஢  ,    楫]"
	goto :scriptEnd)

set checkUrlGGC=https://%$ggc%/generate_204 --output nul
set blackListGGC=%$blackListsDir%\GGC.txt
if not exist "%blackListGGC%" @echo.googlevideo.com>"%blackListGGC%"
call :Show Info "ᯮ  %blackListGGC%"

set /a checkTime=$timeout*($maxRetry + 1) + 1
call :Show Info " 䨣樨   㡠 [ggc]. . ६ 1 ஢ન 1 䨣樨 - %checkTime%x%$checkCount% ᥪ㭤[]"
call :CheckConfig configWorks "%config%" "%checkUrlGGC%" "%blackListGGC%" "%configCheckList%"
if /i "%configWorks%"=="yes" (
	set configCommon=%configCheckList% --hosts '%blackListGGC%' %config% --auto=n
	call :SaveConfigToFile "!configCommon!" "%configName%"
	call :Show Info "  䨣  ᠩ⮢  祪    㡠 [ggc]"
	goto :scriptEnd)

call :FindConfig configGGC "%checkUrlGGC%" "%blackListGGC%" "%configCheckList%"
if not defined configGGC (
	call :Show Warning " 㤠  䨣  襣 GGC. ᫨   ந뢠, : 1. cmd  㡠; 2. ஫  㡥; 3.맮  㧥  F12  CTRL+SHIFT+J; 4.ன  /Network; 5.  㤠  [᭮ 梥]   rr...googlevideo.com; 6.    ࠬ $ggc  '%$iniFile%'[ ,    楫]; 7.  䨣樨  祪  㡮."
	goto :scriptEnd)

set configCommon=%configCheckList% --hosts '%blackListGGC%' %configGGC% --auto=n
call :SaveConfigToFile "%configCommon%" "%configName%"

:scriptEnd
if defined config (
	call :Show Info " 䨣 ࠭  'config_%configName%_Console.cmd'  'config_%configName%_Service.cmd'.  ਯ: '%$logFile%'"
) else (
	call :Show Info " 㤠  ࠡ 䨣. ஡   . ࠬࠬ  '%$iniFile%'. ਬ:  . $browser, $fakeDataTls, $timeout=2.5, $maxRetry=1.  ਯ: '%$logFile%'")
start explorer "%$logFile%"
popd
pause
exit
::-------------------------------------------------------------------------------------------------------
:Show "⨯ ᮮ饭: info/warning/error" "⥪ ᮮ饭"
:: 뢮 ᮮ饭  ࠭   .  砥 訡 蠥 ਯ
setLocal
set type=%~1
set text=%~2
cls
@echo.%type%: %text%
chcp 1251>nul
@echo.%time:~0,8%  %type%: %text%;>>"!$scriptDir!%$logFile%"
chcp 866>nul
if /i "%type%"=="warning" pause
if /i "%type%"=="error" pause & exit
endLocal
exit /b

:FindConfig " ६" "  ଠ curl" "" ". 䨣"
::   ᯨ᪠ ᮢ 䨣 bdpi  頥 
setLocal
set checkUrls=%~2
set blackList=%~3
set configAdd=%~4
set config=
set i=0
set configs.Count=0
for /f "usebackq eol=? tokens=* delims=" %%p in ("%$configsFile%") do (
	set /a i +=1
	@echo  !i!=[%%p]
	call :CheckConfig configWorks "%%p" "%checkUrls%" "%blackList%" "%configAdd%"
	if /i "!configWorks!"=="yes" (
		set config=%%p
		call :Show Info "ਧ ࠡ祩 䨣 !i!: !config!"
		goto :findConfig_end
))
:findConfig_end
endLocal & (
    set %~1=%config%
	set %~1.N=%i%)
exit /b

:CheckConfig " ६" "䨣" "  ଠ curl" "" ". 䨣"
:: ஢ 䨣 byedpi  ᯨ᪠ ᮢ, 頥 yes/no
setLocal
set config=%~2
set checkUrls=%~3
set blackList=%~4
set configAdd=%~5
set isWorking=no
set configFull=%$paramsGlobal% %configAdd% %config%
start /min "%$serviceName%" %$app% --ip %$ip% --port %$port% %configFull:'="%
set loopCount=0
:checkConfig_waitForApp
set /a loopCount +=1
if %loopCount% gtr 10 (
	call :Show Warning "%$app%  ᪠  ࠬࠬ [--ip %$ip% --port %$port% %configFull:'="%]"
	goto :checkConfig_end)
tasklist|findstr /i /c:"%$app%" 1>nul 2>&1 || goto :checkConfig_waitForApp
pushd "%$curlDir%"
for /l %%c in (1,1,%$checkCount%) do (
	if exist "%$curlLog%" del /q /f "%$curlLog%"
	if "%$curlFreezes%"=="no" (
		%$curl% %curlKeys% %checkUrls%
	) else (
		start /min "curl" %$curl% %curlKeys% %checkUrls%
		for /l %%t in (1,1,%checkTime%) do (
			tasklist|findstr /i /c:"%$curl%" 1>nul 2>&1 && timeout /nobreak /t 1 1>nul 2>&1
			type "%$curlLog%" 2>nul|findstr /c:"code=000" 2>nul && goto :checkConfig_end)
		taskkill /t /f /im "%$curl%" 1>nul 2>&1)
	if not exist "%$curlLog%" (
		call :Show Warning "  '%$curlDir%\%$curlLog%'"
		goto :checkConfig_end)
	type "%$curlLog%"|findstr /c:"code=000" && goto :checkConfig_end
)
if /i "%$interactive%"=="yes" (
	call :Show Info " ।⥫쭠 䨣: %config:'="%"
	call :GetChoice isWorking "yes no" " " "1" ", ஢  㧥 ࠡ ᭮ ᠩ⮢  ᯨ᪠ [%blackList%]. । ஢મ 㦭: 1.⪫  㧥 ७ c ஢騪 ४//ப [஬ SmartProxy/ZeroOmega]; 2. DoH  '%$dohFile%'; 3.%textForBrowserVer%; 4.१ 㧥. 樨   䠩 'B-Checker_HELP.txt'.  - ࠭ 䨣  ࠡ.  - த ."
) else (
	set isWorking=yes)
:checkConfig_end
popd
taskkill /t /f /im "%$app%" 1>nul 2>&1
taskkill /t /f /im "%$curl%" 1>nul 2>&1
endLocal & (
    set %~1=%isWorking%)
exit /b

:SaveConfigToFile "䨣" ""
:: ࠭  䠩 䨣  ᮫   㦡
setLocal
set configConsole=%~1
set configName=%~2
set fileConsole=config_%configName%_Console.cmd
set fileService=config_%configName%_Service.cmd
set configConsole=%configConsole:'="%
set configService=!configConsole:--hosts "=--hosts "%%cmdDir%%!
set configService=!configService:"=\"!
if defined $configsDefault set $configsDefaultService=!$configsDefault:"=\"!
(
@echo.taskkill /f /im "%$app%"
@echo.start /min "%$serviceName%" %$app% --ip %$ip% --port %$port% %$paramsGlobal% %configConsole% %$configsDefault%
)>"%fileConsole%"
(
@echo.@echo off
@echo.set "cmdDir=%%~dp0"
@echo.set "cmdDir=%%cmdDir:^=^^%%"
@echo.set "cmdDir=%%cmdDir:&=^&%%"
@echo.set service=%$serviceName%_%configName%
@echo.set cmdLine=\"%%cmdDir%%%$app%\" --ip %$ip% --port %$port% %$paramsGlobal% %configService% %$configsDefaultService%
@echo.taskkill /f /im "%$app%" 1^>nul 2^>^&1
@echo.sc delete "%%service%%"  1^>nul 2^>^&1
@echo.sc create "%%service%%" binPath= "%%cmdLine%%" start= "auto" ^|^| @echo.Error: Can't create service %%service%%. %%~nx0 must be run from Administrator name ^& pause
@echo.sc description "%$serviceName%" "Local SOCKS proxy server to bypass DPI (Deep Packet Inspection)." 1^>nul 2^>^&1
@echo.sc start "%%service%%" 1^>nul ^|^| @echo.Error: Can't start service %%service%%. Check parameters in configuration ^& pause
@echo.if %%errorlevel%%==0 @echo.service %%service%% was started ^& pause
)>"%fileService%"
endLocal
exit /b

:SaveSettingTo "䠩" "ன" "祭"
:: 뢠 祭 ன  䠩 ( ଠ _ன=祭)
:: ᫨ ன 㦥 ,   祭 ९뢠  ࠭ 樨  䠩
:: ᫨  , 뢠   䠩
setLocal
set file=%~1
set setting=%~2
set value=%~3
set string=%setting%=%value%
set settingN=
set n=0
for /f "usebackq eol=? tokens=* delims=" %%s in ("%file%") do (
	set /a n +=1
	set "string.!n!=%%s")
for /f "tokens=1 delims=:" %%n in ('findstr /i /n /b /c:"%setting%=" "%file%" 2^>nul') do set /a settingN=%%n
if defined settingN (
	if /i "!string.%settingN%!"=="%string%" goto :saveSetting_end
	set string.%settingN%=%string%
	(for /l %%i in (1,1,%n%) do @echo.!string.%%i!)>"%file%"
) else (
	@echo.%string%>>"%file%")
:saveSetting_end
endLocal
exit /b

:LoadSettingsFrom "䠩"
:: 㦠 ன  䠩 ( ଠ _ன=祭).  # ⠥ ਥ 
if exist "%~1" for /f "usebackq tokens=1,* delims== eol=#" %%i in ("%~1") do set "%%i=%%j"
exit /b

:GetIpsByNslookup "ᯨ᮪ " "-ࢥ"
:: 頥 ip    ᯨ᪠    ࢥ஬ (᫨  㪠,  c ⥬)
for %%d in (%~1) do (
	for /f "skip=4 tokens=1,* delims=: " %%i in ('nslookup -type^=A -timeout^=3 %%~d. %~2 2^>nul') do (
		@echo.%%j|findstr /r /c:"\<[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\>" 1>nul 2>&1 && set %%d.ip=%%j))
exit /b

:CheckSites " ६" "ᯨ᮪ ᠩ⮢"
:: ஢ 㯭 ᠩ⮢, 頥  室 ᯨ᪠ ᠩ⮢ 2 : 㯭  㯭
setLocal
set sites=%~2
set sitesYes=
set sitesNo=
set checkSites=
for %%s in (%sites%) do set checkSites=%%s --output nul !checkSites!
pushd "%$curlDir%"
for /f "tokens=1,* delims=;" %%c in ('%$curl% %$curlKeys% --max-time 3 --insecure --write-out "%%{response_code};%%{url}\n" --parallel --parallel-immediate %checkSites%') do (
	if not "%%c"=="000" (
		set sitesYes=%%d !sitesYes!
	) else (
		set sitesNo=%%d !sitesNo!))
popd
endLocal & (
	set %~1.Yes=%sitesYes%
	set %~1.No=%sitesNo%)
exit /b

:CheckIps " ६" "ᯨ᮪ "
:: 頥  室 ᯨ᪠  2 : 㯭  㯭  ip
:: ᫨   ⢥砥   sni 㯭 ᠩ,   㯥  ip
:: ip   쭮 ६ .ip,  ਬ ya.ru.ip - ६  祭 77.88.44.242
:: ᫨ ip  , curl  ⥬ ip  
setLocal
set domains=%~2
set domainsIpYes=
set domainsIpNo=
pushd "%$curlDir%"
for %%d in (%domains%) do if exist "curl_%%d.log" del /q /f "curl_%%d.log"
for %%d in (%domains%) do (
	if defined %%d.ip (
		start /min "test ips" %$curl% %$curlKeys% --max-time 3 --insecure --write-out "%%output{>>"curl_%%d.log"}code=%%{exitcode};!%%d.ip!\n" --parallel --parallel-immediate https://%sni% --output nul --connect-to %sni%::!%%d.ip! http://%sni% --output nul --connect-to %sni%::!%%d.ip!
	) else (
		start /min "test ips" %$curl% %$curlKeys% --max-time 3 --insecure --write-out "%%output{>>"curl_%%d.log"}code=%%{exitcode};%%{remote_ip}\n" --parallel --parallel-immediate https://%sni% --output nul --connect-to %sni%::%%d http://%sni% --output nul --connect-to %sni%::%%d
	))
for /l %%t in (1,1,4) do (
	tasklist|findstr /i /c:"%$curl%" 1>nul 2>&1 && timeout /nobreak /t 1 1>nul 2>&1)
taskkill /t /f /im "%$curl%" 1>nul 2>&1
for %%d in (%domains%) do (
	type "curl_%%d.log"|findstr /c:"code=0;" 1>nul 2>&1 && (
		set domainsIpYes=%%d !domainsIpYes!
	) || (
		set domainsIpNo=%%d !domainsIpNo!))
for %%d in (%domains%) do if exist "curl_%%d.log" del /q /f "curl_%%d.log"
popd
endLocal & (
	set %~1.IpYes=%domainsIpYes%
	set %~1.IpNo=%domainsIpNo%)
exit /b

:CheckDoh " ६" " DoH" "ᯨ᮪ "
:: ஢ DoH  ᯨ᪠ , 頥 true, ᫨   㯭  DoH,  false
::  ࠡ稥 ip 뢠  䠩 $ipsFile
setLocal
set dohUrl=%~2
set domains=%~3
set accessAll=true
pushd "%$curlDir%"
for %%d in (%domains%) do if exist "curl_%%d.log" del /q /f "curl_%%d.log"
for %%d in (%domains%) do (
	start /min "test doh" %$curl% %$curlKeys% --write-out "%%output{>>"curl_%%d.log"}%%{response_code};%%{remote_ip}\n" --max-time 4 --insecure --doh-insecure --doh-url "%dohUrl%" --parallel --parallel-immediate https://%sni% --output nul --connect-to %sni%::%%d http://%sni% --output nul --connect-to %sni%::%%d
)
for /l %%t in (1,1,5) do (
	tasklist|findstr /i /c:"%$curl%" 1>nul 2>&1 && timeout /nobreak /t 1 1>nul 2>&1)
taskkill /t /f /im "%$curl%" 1>nul 2>&1
for %%d in (%domains%) do (
	set access=false
	set %%d.ip=
	for /f "usebackq tokens=1,* delims=;" %%i in ("curl_%%d.log") do (
		if not "%%i"=="000" (
			set %%d.ip=%%j
			set access=true))			
	if /i "!access!"=="false" set accessAll=false)
for %%d in (%domains%) do if exist "curl_%%d.log" del /q /f "curl_%%d.log
popd
for %%d in (%domains%) do if defined %%d.ip call :SaveSettingTo "%$ipsFile%" "%%d.ip" "!%%d.ip!"
endLocal & (
	set %~1=%accessAll%)
exit /b

:GetChoice " ६" "ᯨ᮪ 祭" "ᯨ᮪ " " 祭  㬮砭" "⥪"
:: 頥 祭, ࠭  ᯨ᪠ (     ࠭ 㭪)
:: ᫨ 祭/ ᮤঠ ஡,  맮  㦭   ''
setLocal
set values=%~2
set valueNames=%~3
set valueN=%~4
set text=%~5
set values=!values:'="!
if not defined values call :Show Error "  ᯨ᮪ 祭  롮 %~1"
if defined valueNames (
	set valueNames=!valueNames:'="!
	set count=0 
	for %%j in (!valueNames!) do (
		set /a count +=1
		set valueName.!count!=%%~j))
set count=0
for %%i in (%values%) do (
     set /a count +=1	 
     set value.!count!=%%~i)
@echo.%text%	 
for /l %%n in (1,1,%count%)	do (
	if defined valueName.%%n (
		@echo.%%n. !valueName.%%n!: !value.%%n!
	) else (
		@echo.%%n. !value.%%n!))
:choiceLoop
set choiceN=%valueN%
set /p choiceN=  ࠭ 㭪 ( 1  %count% ,  㬮砭 %valueN% [!value.%choiceN%!])   Enter: 
set result=!value.%choiceN%!
set resultName=!valueName.%choiceN%!
if not defined result (
	@echo.:   %choiceN%    1  %count%
	goto :choiceLoop)
endLocal & (
    set %~1=%result%
	set %~1.Name=%resultName%
	set %~1.N=%choiceN%)
exit /b

:GetLocalGGCs " ६"
:: 頥 ᯨ᮪   ggc
setLocal
set redirUrls=gvt1.com c.youtube.com c.googlevideo.com googlevideo.com
set urls=
set localGGC=
set result=
pushd "%$curlDir%"
for %%u in (%redirUrls%) do (
	for %%h in (https http) do (
		set urls=!urls! "%%h://redirector.%%u/report_mapping?di=no"))
for /f "tokens=3" %%g in ('%$curl% %$curlKeys% --max-time 3 --parallel --parallel-immediate --insecure %urls%') do (
	set localGGC=%%g
	if defined localGGC goto :localGGC_end)
:localGGC_end
popd
if defined localGGC (
	call :Decode localGGCDecoded "%localGGC%"
	for /l %%i in (1,1,12) do set result=!result! rr%%i---sn-!localGGCDecoded!.googlevideo.com)
endLocal & (
	set %~1=%result%)
exit /b

:Decode " ६" "室 ப"
:: 頥 ப, ஢  ࠢ ஢
setLocal
set string=%~2
set charsDecoded=0 1 2 3 4 5 6 7 8 9 a b c d e f g h i j k l m n o p q r s t u v w x y z - _
set chars=u z p k f a 5 0 v q l g b 6 1 w r m h c 7 2 x s n i d 8 3 y t o j e 9 4 - _
set result=
set n=0
for %%c in (%chars%) do (
	set chars.!n!=%%c
	set /a n+=1)
set n=0	
for %%d in (%charsDecoded%) do (
	set charsDecoded.!n!=%%d
	set /a n+=1)
for /l %%i in (0,1,255) do (
	set char=!string:~%%i,1!
	if not defined char goto :decode_end
	for /l %%j in (0,1,%n%) do (
		if !char!==!chars.%%j! set result=!result!!charsDecoded.%%j!))
:decode_end
endLocal & (
	set %~1=%result%)
exit /b

:SetCodePage " ࠭"
:: ⠭ . ஢  ப [866/1251/65001]( ᮢ  ஢ ਯ)
setLocal
set CodePage=%~1
set FaceName="Lucida Console"
set FontFamily=0x0000036
set FontWeight=0x0000190
set FontSize=0x000d0000
set CodePage.Type=REG_DWORD
set FaceName.Type=REG_SZ
set FontFamily.Type=REG_DWORD
set FontWeight.Type=REG_DWORD
set FontSize.Type=REG_DWORD
set regKey=HKEY_CURRENT_USER\Console\%%SystemRoot%%_system32_cmd.exe
set cp866=0x362
set cp1251=0x4e3
set cp65001=0xfde9
@echo.866 1251 65001|findstr /v %CodePage% 1>nul 2>&1 && call :Show Error "Code page must be 866/1251/65001"
for /f "eol= tokens=3*" %%c in ('reg query %%regKey%% /v "CodePage" 2^>nul') do set cmdCodePage16=%%c
if defined cmdCodePage16 call :Show Info " ᪮ 樨 ਯ  ॥  ⪠ %%regKey%%"
if "%cmdCodePage16%"=="!cp%CodePage%!" endLocal & exit /b
for /f "tokens=1,* delims=:" %%i in ('chcp') do set cmdCodePage=%%~j
cls
if %cmdCodePage%0==%CodePage%0 endLocal & exit /b
for %%p in (CodePage FaceName FontFamily FontWeight FontSize) do reg add %regKey% /v %%p /t !%%p.Type! /d !%%p! /f 1>nul 2>&1 || call :Show Error "%$scriptFile% must be run from Administrator name"
@echo.Restarting %$scriptFile% for russian localization
pause
start "" %$scriptFile%
exit